\section{Benchmarks and methodology}

When trying to evaluate any software, it is important to have a somewhat reasonable set of test cases that represent the important use cases for the software at hand and allow to check for the interesting qualitative and quantitative properties of the runs.
In our case, the software being tested are different solvers that we check for correctness, memory usage, and run time.
The set of test cases (or \emph{benchmarks}) is taken from the \SMTLIB benchmark set~\cite{Barrett2016}, arguably the standard set for SMT solving. Unless explicitly stated otherwise, we always refer to the quantifier-free nonlinear real arithmetic benchmarks (called \QFNRA).

The \SMTLIB benchmark sets are usually organized into ``families'', where each family contains a number of benchmarks that usually come from a particular application and thus also share common characteristics.
Given that the number of benchmarks per family varies wildly, it is an ongoing discussion in the SMT community how to compare different solvers across such a benchmark set, for example, witnessed by regularly changing scoring rules for the SMT competition.

We sometimes observe that the performance of different heuristics significantly varies across these families, giving an apparent advantage to heuristics that happen to work better on larger families.
We do not engage in this kind of analysis throughout this thesis and only consider the overall number of solved instances, as
\begin{enumerate*}
	\item there is no other metric that enjoys a similarly widespread acceptance throughout the community,
	\item there is no point in analyzing the specific characteristics of the individual families for this thesis and
	\item it would multiply the space and effort needed for our evaluation without a clear benefit.
\end{enumerate*}
Instead, we encourage the reader to evaluate multiple variants of the proposed techniques on the particular problems of interests, even if they performed rather badly for us.

Separate from the question of how we use this benchmark, we need to understand that this benchmark set is not the absolute truth. Being only a collection of benchmarks -- the best we have, though -- it merely contains whatever someone submitted at some point.
Some benchmarks are clearly artificial while others stem from actual applications that use SMT queries in their backends. However, rumor has it that some of these were generated by feeding artificial problems to these applications, making the resulting SMT queries somewhat artificial as well.
Altogether, we can use this benchmark set as an indicator for performance but need to be cautious to extrapolate to new applications.

To get a feeling for this set of benchmarks, we give a rough analysis of its characteristics.
For this, we parsed the problem instances with \SMTRAT and extracted some statistical data from the resulting formulae.
Note that some amount of simplification and normalization is performed while constructing the formulae.

\begin{figure}
	\centering
	\includetikz{02f-fileinfo-answer}
	\caption{Known satisfiability}\label{fig:benchmarks:answer}
\end{figure}

Firstly, \cref{fig:benchmarks:answer} shows the known satisfiability of all problem instances where \emph{unknown} represents files without annotation or unknown status. Having checked that no solvers produce conflicting results, we assume a problem to have SAT or UNSAT status if they are annotated by \SMTLIB or any solver can solve them.

\begin{figure}
	\centering
	\includetikz{02f-fileinfo-numvars}
	\caption{Number of variables}\label{fig:benchmarks:numvars}
\end{figure}

The number of variables is one of the main drivers of asymptotic complexity for essentially all methods that are discussed in this thesis. We see in \cref{fig:benchmarks:numvars} that almost two-thirds of the benchmarks only contain a low number of variables (below $10$), but also a few hundred with a thousand or more variables are present.

More than three-quarters of the benchmarks contain no Boolean variables at all, which already indicates a low Boolean complexity in most cases -- though this might change after Tseitin's transformation.
Interestingly, we observe that $461$ examples have no variables at all, mostly because normalization and naive simplifications were sufficient to reduce the formula to \true or $\false$.

\begin{figure}
	\centering
	\includetikz{02f-fileinfo-numconstraints}
	\caption{Number of constraints and equalities}\label{fig:benchmarks:numconstraints}
\end{figure}

The number of constraints also plays a considerable role and we see some statistics in \cref{fig:benchmarks:numconstraints}. Once again, we observe that $461$ benchmarks were simplified to either \true or $\false$ and thus contain no constraints. About half of the benchmarks have at most ten constraints, though the maximum is at almost $250k$.

More interesting observations can be drawn from the degrees of the constraints.
Comparing the sum of all degrees with the number of constraints indicates that the average degree is rather small and usually less than two. The maximum degree, however, is significantly larger, growing up to $44$.
We infer that many examples consider only a few (or even only a single one) high-degree constraint in conjunction with a larger set of low-degree constraints, apparently linear in many cases.
This observation motivates a number of techniques that aim to exploit linear constraints in particular, for example~\cite{Loup2013} or variable elimination from \cref{ssec:cad:resultant-rule}.

We also observe that more than a third of the examples contain a significant number of equalities, which also allows for effective simplifications in many cases as we discuss for example in \cref{ssec:cad:equational-constraints} or \cref{ssec:cad:resultant-rule}.

\subsection{Preprocessing and tuned heuristics}

We now try to give some intuition on how different components of a solver might contribute to the overall solving performance and how we are going to analyze the practical performance of a solver.
To do this we exemplarily look at the performance of the SMT solver \Zthree~\cite{Moura2008} that is shown in \cref{fig:benchmarks:z3} on this benchmark set.
\Zthree implements an \MCSAT{} -- or more specifically \NLSAT{} -- approach which is explained in more detail in \cref{ch:mcsat}.

\begin{figure}
	\centering
	\includetikz{02f-benchmark-z3}
	\caption{Run times of \Zthree (seconds)}\label{fig:benchmarks:z3}
\end{figure}

First, we observe that a longer timeout is unlikely to yield more results as the required run time tends to grow exponentially in practice. Consider, for example, the results shown in \cref{fig:benchmarks:z3}. We see that more than $90\%$ of the instances -- that can be solved within $20$ minutes -- are already solved within $0.1$ seconds and less than $0.5\%$ of the solved ones required more than $20$ seconds.

Altogether, we can say that we either solve a benchmark instantly -- within a few seconds -- or there is a good chance that we cannot solve it in a practically acceptable time at all. It seems tempting to immediately argue with the doubly-exponential run-time behavior of CAD which is the underlying technique of the \NLSAT solver that \Zthree ultimately uses for this logic.

\begin{figure}
	\centering
	\begin{subfigure}[t]{0.35\textwidth}
		\vspace{0pt}\centering
		\input{experiments/output/table-solved-within-z3.tex}
	\end{subfigure}\hfill
	\begin{subfigure}[t]{0.6\textwidth}
		\vspace{0pt}\centering
		\input{experiments/output/table-z3-nlsat-properties.tex}
	\end{subfigure}
	\caption{Statistics of \Zthree on \QFNRA}\label{fig:benchmarks:z3-statistics}
\end{figure}

We should, however, put this claim into perspective and give some selected views on the \Zthree solving statistics. We see in \cref{fig:benchmarks:z3-statistics} that about $1650$ problems do not enter the \NLSAT solver at all -- note that the $8457$ problems that have at least one propagation cover all the ones below.

Moreover, only $7749$ instances create at least a single stage -- selecting a theory variable to be assigned -- indicating that the difference of about $700$ problems never even considers performing a theory decision. Only $5323$ ever finish conflict resolution at least once -- thus $3134$ problems either detect unsatisfiability upon the first conflict or construct a satisfying assignment on the first try for theory and Boolean variables.

The situation gets even worse if we look for problems where \emph{actual solving happens} in the sense that we need all the (theoretic) power that the solver has. One could very well argue that benchmarks where solving hits (almost) no conflicts are essentially trivial -- and we have only $2255$ problem instances that show at least five conflicts.

\subsection{Presentation of experimental results}

Throughout the thesis, we show experimental results that analyze the impact of individual features or different configurations.
We thus use a ``minimal solver''-- for example just a SAT solver and a CAD-based theory solver -- without applying more involved preprocessing techniques.

All benchmarks presented throughout this thesis were run on Intel Xeon Platinum 8160 processors and were allowed to use up to four gigabytes of memory and two minutes of processor time.
If run times tend to vary from one execution to the next, it is sometimes reasonable to perform multiple runs and present average values. All our solvers -- and we assume this to hold for \Zthree as well -- are completely deterministic and, thus, the fluctuations of the needed computation time are marginal in practice.

\begin{figure}
	\centering
	\input{experiments/output/table-z3.tex}
	\caption{Experimental results for \Zthree}\label{fig:results:z3}
\end{figure}

Consider \cref{fig:results:z3} for an illustrative example of benchmark results.
For every solver (here only \Zthree), we show the number of satisfiable and unsatisfiable instances that were correctly solved, as well as the average run time for the solved instances. Additionally, we show the overall number of solved instances and also give the percentage of solved instances from the overall benchmark set.
In this case, \Zthree solves $10103$ instances (from these $5004$ satisfiable and $5099$ unsatisfiable) which are $87.9\%$ of the benchmark set (that consists of $11489$ instances altogether).
On the remaining $1386$ instances, \Zthree exhausted the resources (either time or memory).
No solver presented in this thesis yielded incorrect results.
